=== debian/changelog ===
ros-foxy-psen-scan-v2 (0.20.0-1focal) focal; urgency=high

  * Port to ros2 foxy (#270)
    
    Rename launch files to *.launch.xml
    
    <string>:8: (WARNING/2) Inline emphasis start-string without end-string.
    
    Update README.md
    
    Add migration notes
    
    Remove delay in signal handler
    
    Introduce _ROS_BUILD_ define in order to choose between ros2 and (pure) cpp logging
    
    Rename ParamMissingOnServer to ParameterNotSet
    
    Allow more flexibel usage of util::Barrier
    
    Add linter clang-format and xmllint
  * Update REAMDE.md
  * Minor improvement of TenthOfDegree
  * Fix scanner destruction problems. Fixes #241
  * Remove dependency on pilz_testutils
  * Always build hardware tests
  * Internal refactorings
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Tue, 30 Nov 2021 23:00:00 -0000

ros-foxy-psen-scan-v2 (0.3.2-1focal) focal; urgency=high

  * Improve performance of standalone part
    
    Introduce RawDataPtr
    
    Write to std::stringstream instead of constructing from std::string
    
    Pass by reference wherever possible
  * Make release build the default
  * Calculate timestamp as the time of the first ray (udp communication time is neglected)
  * API: Add timestamp (nanoseconds since epoch) to LaserScan
  * API: Add scan counter to LaserScan
  * API: remove LaserScan equality operator
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Wed, 15 Sep 2021 22:00:00 -0000

ros-foxy-psen-scan-v2 (0.3.1-1focal) focal; urgency=high

  * Rename urdf links
  * Apply tf prefix equals node name
  * API change: rename launch-file argument prefix->tf_prefix
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Tue, 20 Jul 2021 22:00:00 -0000

ros-foxy-psen-scan-v2 (0.3.0-1focal) focal; urgency=high

  * Set prefix for node name (same value as for tf frames)
  * Introduce bringup.launch for starting only the scanner node
  * Omit closing the data client before destruction. Fixes #212
  * Distance value at angle_end is now included in the scan range
  * Default scan range changed to [-137.4..137.4]deg at 0.1 deg resolution
  * Add options for modifying resolution and enabling intensities
  * Add launchfile option for disabling rviz at startup (default: enable)
  * Handle the infinity codes from the scanner correctly
  * Inform user about current scan range
  * Fix wrong behavior when angle_start and angle_end are equal
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Mon, 28 Jun 2021 22:00:00 -0000

ros-foxy-psen-scan-v2 (0.2.1-1focal) focal; urgency=high

  * Fix issues with smaller angle ranges than default range (#183 <https://github.com/PilzDE/psen_scan_v2/issues/183>)
  * Add action for pull request todos (#184 <https://github.com/PilzDE/psen_scan_v2/issues/184>)
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Sun, 18 Apr 2021 22:00:00 -0000

ros-foxy-psen-scan-v2 (0.2.0-1focal) focal; urgency=high

  * Combine multiple monitoring frames into one scan (#173 <https://github.com/PilzDE/psen_scan_v2/issues/173>)
  * Contributors: Pilz GmbH and Co. KG
  * API change: Driver waits for scan round to complete before sending measurement data by default
  * Introducing new parameter fragmented_scans to switch back to faster fragmented laser_scan messages
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Sun, 04 Apr 2021 22:00:00 -0000

ros-foxy-psen-scan-v2 (0.1.6-1focal) focal; urgency=high

  * Separate ROS and standalone CMakeLists: Closes #169
  * Minor restructuring. Closes #175
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Sun, 21 Mar 2021 23:00:00 -0000

ros-foxy-psen-scan-v2 (0.1.5-1focal) focal; urgency=high

  * Make specifying host ip optional
  * Reorder Readme sections
  * API change: A scan is published only if it contains measurement data
  * Make tests build in standalone with or without ROS installed
  * Document key components in a meaningful expressive way
  * Enable building the standalone lib using MSVC
  * Enable separate building of cpp-lib; extract sources into subproject psen_scan_v2_standalone
  * Renames ScanRange and DefaultScanRange to improve usability
  * Improve namespace hierarchy and move files to respective subfolders
  * Use defaults ports in ScannerConfiguration
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Tue, 09 Mar 2021 23:00:00 -0000

ros-foxy-psen-scan-v2 (0.1.4-1focal) focal; urgency=high

  * Add internal error handling for detecting regressions in the scanner firmware
  * Make specifying udp ports optional
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Tue, 12 Jan 2021 23:00:00 -0000

ros-foxy-psen-scan-v2 (0.1.3-1focal) focal; urgency=high

  * Add ROS noetic support (#103 <https://github.com/PilzDE/psen_scan_v2/issues/103>)
  * Use TYPED_TEST_SUITE instead of deprecated TYPED_TEST_CASE
  * Apply fixes from clang-format (#113 <https://github.com/PilzDE/psen_scan_v2/issues/113>)
  * Spelling measurements (#112 <https://github.com/PilzDE/psen_scan_v2/issues/112>)
  * Directly use fmt lib instead of rosfmt (#108 <https://github.com/PilzDE/psen_scan_v2/issues/108>)
  * Fix clang tidy errors (#109 <https://github.com/PilzDE/psen_scan_v2/issues/109>)
  * Feature/api documentation improvement (#100 <https://github.com/PilzDE/psen_scan_v2/issues/100>)
  * Improve the API documentation
  * Add ROS Noetic support
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Tue, 08 Dec 2020 23:00:00 -0000

ros-foxy-psen-scan-v2 (0.1.2-1focal) focal; urgency=high

  * Add Scanner ports in ScannerConfiguration
  * Switch branching model: Introduce main branch
  * Use github actions
  * Adds missing error bit

