=== debian/control ===
Source: ros-foxy-psen-scan-v2
Section: misc
Priority: optional
Maintainer: Alexander Gutenkunst <a.gutenkunst@pilz.de>
Build-Depends: debhelper (>= 9.0.0), libboost-system-dev, libconsole-bridge-dev, libfmt-dev, python3-pytest, ros-foxy-ament-cmake, ros-foxy-ament-cmake-clang-format, ros-foxy-ament-cmake-gtest, ros-foxy-ament-cmake-ros, ros-foxy-ament-cmake-xmllint, ros-foxy-ament-index-python, ros-foxy-launch, ros-foxy-launch-ros, ros-foxy-launch-testing, ros-foxy-launch-xml, ros-foxy-rclcpp, ros-foxy-rclpy, ros-foxy-rcutils, ros-foxy-ros-testing, ros-foxy-rosbag2-cpp, ros-foxy-rosbag2-storage-default-plugins, ros-foxy-sensor-msgs, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-psen-scan-v2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-system-dev, libfmt-dev, ros-foxy-launch-ros, ros-foxy-rclcpp, ros-foxy-rcutils, ros-foxy-robot-state-publisher, ros-foxy-rviz2, ros-foxy-sensor-msgs, ros-foxy-xacro, ros-foxy-ros-workspace
Description: ROS support for the Pilz laser scanner
